/*
 * $RCSfile$
 * $Revision: 88934 $
 *
 * Comments:
 *
 * (C) Copyright ParaSoft Corporation 1996.  All rights reserved.
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft
 * The copyright notice above does not evidence any
 * actual or intended publication of such source code.
 *
 * $Author: mali $          $Locker$
 * $Date: 2008-04-11 14:47:20 +0200 (Pt, 11 kwi 2008) $
 * $Log$
 * Revision 1.1  2005/07/07 13:43:17  dario
 * added
 *
 */

#ifndef _BLOWFISH_ENCODER_
#define _BLOWFISH_ENCODER_


#define N              16
#define noErr          0
#define DATAERROR      -1
#define KEYBYTES       8

/**
 * This class is based on alex library (logfile.cc)
 * Its used to encode/decode win32 machine identifiers.
 */
class BlowfishEncoder
{
public:
    BlowfishEncoder(const char *key, short keybytes);
    ~BlowfishEncoder(void);
    
    void write(unsigned int *xl, unsigned int *xr);
    void read(unsigned int *xl, unsigned int *xr);
private:
    void initialize(const char *key, short keybytes);
    unsigned int F(unsigned int x);
  
    bool isLittleEndian();
    
    unsigned int P[N + 2];
    unsigned int S[4][256];
            
};

#endif // _BLOWFISH_ENCODER_
