/*
 * $RCSfile: NativeNetworkInfo.cc,v $
 * $Revision: 1.3 $
 *
 * Comments:
 *
 * (C) Copyright ParaSoft Corporation 1996.  All rights reserved.
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft
 * The copyright notice above does not evidence any
 * actual or intended publication of such source code.
 *
 * $Author: franczak $          $Locker:  $
 * $Date: 2008-03-26 13:08:20 $
 * $Log: not supported by cvs2svn $
 * Revision 1.2  2005/11/29 14:39:48  mlyko
 * Include from solaris directory for solaris arch.
 *
 * Revision 1.1  2005/08/23 09:07:30  mlyko
 * Original source code.
 *
 */

#include "Common.h"
#include "NativeNetworkInfo.h"

#include "NetworkInfo.h"

const char* JAVA_STRING_TYPE = "Ljava/lang/String;";

const char* JAVA_HOST_ADDRESS_VARIABLE = "_sHostAddress";
const char* JAVA_NET_MASK_VARIABLE = "_sNetworkMask";
const char* JAVA_NET_BROADCAST_VARIABLE = "_sNetworkBroadcast";

JNIEXPORT void JNICALL Java_com_parasoft_xtest_common_nativecode_NativeNetworkInfo_readNetworkInfo
  (JNIEnv * env, jobject obj)
  {
    char ip[20];
    char mask[20];
    char broadcast[20];
    
    NetworkInfo ni;
    ni.ReadNetworkInfo(ip, mask, broadcast);

    jclass cls = env->GetObjectClass(obj);
    jfieldID fid = env->GetFieldID(cls, JAVA_HOST_ADDRESS_VARIABLE, JAVA_STRING_TYPE);
    if (fid == NULL) {
        return; /* failed to find the field */
    }
    jstring jstr = env->NewStringUTF(ip);
    if (jstr == NULL) {
        return; 
    }
    env->SetObjectField(obj, fid, jstr);

    fid = env->GetFieldID(cls, JAVA_NET_MASK_VARIABLE, JAVA_STRING_TYPE);
    if (fid == NULL) {
        return; /* failed to find the field */
    }
    jstr = env->NewStringUTF(mask);
    if (jstr == NULL) {
        return; 
    }
    env->SetObjectField(obj, fid, jstr);

    fid = env->GetFieldID(cls, JAVA_NET_BROADCAST_VARIABLE, JAVA_STRING_TYPE);
    if (fid == NULL) {
        return; /* failed to find the field */
    }
    jstr = env->NewStringUTF(broadcast);
    if (jstr == NULL) {
        return; 
    }
    env->SetObjectField(obj, fid, jstr);
  }
